#!/usr/bin/env perl

# Xmas Contest 2010
# Problem F
# Christmas Magic

# Output Checker

# use bigint;

open (IN, $ARGV[0]); @input  = <IN>; close (IN);
open (IN, $ARGV[1]); @output = <IN>; close (IN);
open (IN, $ARGV[2]); @ansput = <IN>; close (IN);

for ($tc = 1; ; ++$tc) {
	# read in
	($m, $n, $k) = split (/\s/, $input[0]); shift (@input);
	if ($m == 0 && $n == 0 && $k == 0) {
		if (@output != 0) {
			die ("Wrong Answer: Excessive Output", $/);
		}
		die ("Correct Answer", $/);
	}
	for $i (0 .. $m) { for $j (0 .. $n) { $in[$i][$j] = 0; } }
	for $i (0 .. $m - 1) {
		@x = split (/\s/, $input[0]); shift (@input);
		for $j (0 .. $n - 1) {
			$in[$i][$j] += $x[$j];
			$in[$i][$n] += $x[$j];
			$in[$m][$j] += $x[$j];
			$in[$m][$n] += $x[$j];
		}
	}
	shift (@input);
	
	# read out
	for $i (0 .. $m) { for $j (0 .. $n) { $out[$i][$j] = 0; } }
	for $i (0 .. $m - 1) {
		@x = split (/\s/, $output[0]); shift (@output);
		if (@x != $n) {
			die ("Wrong Answer (Case $tc): Incorrect Number of Elements (Row $i)", $/);
		}
		for $j (0 .. $n - 1) {
			if ($x[$j] =~ /\D/) {
				die ("Wrong Answer (Case $tc): Not Non-negative Integer (Cell $i, $j)", $/);
			}
			if ($x[$j] =~ /.{11}/) {
				die ("Wrong Answer (Case $tc): Too Large Value (Cell $i, $j)", $/);
			}
			$out[$i][$j] += $x[$j];
			$out[$i][$n] += $x[$j];
			$out[$m][$j] += $x[$j];
			$out[$m][$n] += $x[$j];
		}
	}
	@x = split (/\s/, $output[0]); shift (@output);
	if (@x != 0) {
		die ("Wrong Answer (Case $tc): No Empty Line", $/);
	}
	
	# read ans
	for $i (0 .. $m) { for $j (0 .. $n) { $ans[$i][$j] = 0; } }
	for $i (0 .. $m - 1) {
		@x = split (/\s/, $ansput[0]); shift (@ansput);
		for $j (0 .. $n - 1) {
			$ans[$i][$j] += $x[$j];
			$ans[$i][$n] += $x[$j];
			$ans[$m][$j] += $x[$j];
			$ans[$m][$n] += $x[$j];
		}
	}
	shift (@ansput);
	
	# check
	$l = $in[$m][$n];
	$ans_sum = $out_sum = 0;
	for $i (0 .. $m) { for $j (0 .. $n) {
		$r = $in[$i][$j] * $k % $l;
		$q = ($in[$i][$j] * $k - $r) / $l;
		if (!($out[$i][$j] == $q || $out[$i][$j] == $q + 1 && $r != 0)) {
			die ("Wrong Answer (Case $tc): Inappropriate Rounding (Cell $i, $j)", $/);
		}
		if ($out[$i][$j] == $q + 1) { $out_sum += $l - 2 * $r; }
		if ($ans[$i][$j] == $q + 1) { $ans_sum += $l - 2 * $r; }
	} }
	if ($out_sum < $ans_sum) {
		die ("Fatal Error!!!!!!!!!! (Case $tc)", $/);
	} elsif ($out_sum > $ans_sum) {
		die ("Wrong Answer (Case $tc): Not Minimized", $/);
	}
	
}

